// SCardMap.cpp: Implementierung der Klasse SCardMap.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "stdafx.h"
#include "SCardMap.h"

#include <stdlib.h>
#include <time.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

const float GRENZE_X = 15.0;
const float GRENZE_Y = 15.0;

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

SCardMap::SCardMap()
{
	srand(time(NULL));

	openCards[0] = 0;
	openCards[1] = 0;
	howMany = 0;
}

SCardMap::~SCardMap()
{

}

void SCardMap::draw(float frameTime)
{
	for (int i = 0; i < MAX_CARDS; i += 1)
	{
		cards[i].draw(frameTime);
	}

	checkMap();
}

void SCardMap::click(float xPos, float yPos)
{
	if (howMany == 2)
	{
		return;
	}

	for (int i = 0; i < MAX_CARDS; i += 1)
	{
		if (cards[i].getStatus() == HIDDEN)
		{
			if(cards[i].isInside(xPos,yPos))
			{
				openCards[howMany] = i;
				cards[i].click();
				howMany += 1;

				break;
			}
		}
	}
	
	//checkMap();
}

void SCardMap::create(unsigned int glTex,float initX, float initY)
{
	howMany = 0;
	int cardColor[12] = {0};
	int nextColor = 7;

	float nextX = /*-GRENZE_X + xSize - 1.0*/initX;
	float nextY = /*GRENZE_Y - ySize - 1.0*/initY;

	for (int i = 0; i < MAX_CARDS; i += 1)
	{
		if (i)
		{
			if (!(i % 6))
			{
				nextY -= 2*ySize + 0.25f;
				nextX = initX;
			}
		}
		do
		{
			nextColor = (rand() % 12)+1 ;
		}
		while (cardColor[nextColor-1] == 2);

		cardColor[nextColor-1] += 1;

		cards[i].create(nextX,nextY,glTex,nextColor);
		
		nextX += 2.0f*xSize + 0.5f;
	}
}

void SCardMap::checkMap()
{
	int first = openCards[0];
	int second = openCards[1];

	
	if (howMany == 2)
	{
		if (cards[first].getStatus() != SHOWN ||
			cards[second].getStatus() != SHOWN)
		{
			return;
		}

		if (cards[first].getType() == cards[second].getType())
		{
			cards[first].setStatus(INVISIBLE);
			cards[second].setStatus(INVISIBLE);

			howMany = 0;
		}
		else
		{
			cards[first].setStatus(TURNING_OUT);
			cards[second].setStatus(TURNING_OUT);

			howMany = 0;
		}
	}
}	
