// SMemoryCard.h: Schnittstelle fr die Klasse SMemoryCard.
//
//////////////////////////////////////////////////////////////////////

#ifndef S_MEMORYCARD_H
#define S_MEMORYCARD_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <gl\gl.H>

static const float xSize = 1.05f;
static const float ySize = 1.40f;


enum SCardStatus
{
	HIDDEN,
	SHOWN,
	INVISIBLE,
	TURNING_IN,
	TURNING_OUT
};




class SMemoryCard  
{
public:
	void click();
	bool isInside(float xPos, float yPos);
	void setStatus(SCardStatus state);
	SCardStatus getStatus();
	int getType();
	void draw(float frameTime);
	void create(float xPos, float yPos, unsigned int glTex, int type);
	SMemoryCard();
	virtual ~SMemoryCard();
protected:
	float* getCardColor();
	void drawCard();
	unsigned int backTexture;
	SCardStatus cardStatus;
	float position[2];
	int cardType;
	float rotation;
};

#endif 