// SOutlineFont.cpp: Implementierung der Klasse SOutlineFont.
//
// Copyright by Andr Stein
// E-Mail: andre_stein@gmx.de, andre_stein@web.de
// http://stonemaster.port5.com
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SOutlineFont.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

SOutlineFont::SOutlineFont()
{
	infos = new GLYPHMETRICSFLOAT[256];
}

SOutlineFont::~SOutlineFont()
{
	delete[] infos;
}

void SOutlineFont::drawText(SAlign alignment, const char *string, ...)
{
	va_list argList;
	char text[256];
	float length = 0;

	if (!listBase || !string)
	{
		return;
	}

	va_start(argList,string);
		vsprintf(text,string,argList);
	va_end(argList);

	for (int i = 0; i < strlen(text); i += 1)
	{
		length += infos[text[i]].gmfCellIncX;
	}

	switch (alignment)
	{
	case RIGHT:
		glTranslatef(-length,0.0,0.0);
		break;
	case CENTER:
		glTranslatef(-length/2.0,0.0,0.0);
		break;
	}

	glPushAttrib(GL_LIST_BIT);
	glListBase(listBase);
	glCallLists(strlen(text),GL_UNSIGNED_BYTE,text);
	glPopAttrib();
}

bool SOutlineFont::createFont(HDC hDC, const char *fontname, int height, float thickness, SFontAttri attributes)
{
	HFONT font;

	listBase = glGenLists(256);

	if (!listBase)
	{
		return false;
	}
	
	font = CreateFont(height,0,0,0,attributes.bold,
		attributes.italic,attributes.underline,FALSE,ANSI_CHARSET,
		OUT_TT_PRECIS,CLIP_DEFAULT_PRECIS,ANTIALIASED_QUALITY,
		FF_DONTCARE | DEFAULT_PITCH,fontname);

	SelectObject(hDC,font);

	wglUseFontOutlines(hDC,0,255,listBase,
		0.0,
		thickness,
		WGL_FONT_POLYGONS,
		infos);

	return true;
}
