// SScreenMode.cpp: Implementierung der Klasse SScreenMode.
//
// Copyright by Andr Stein
// E-Mail: andre_stein@gmx.de, andre_stein@web.de
// http://stonemaster.port5.com
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SScreenMode.h"


//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

SScreenMode::SScreenMode()
{
	
}

SScreenMode::~SScreenMode()
{
	reset();
}

SScreenMode::SScreenMode(int width, int height, int bpp)
{
	if (!setDisplayMode(width, height, bpp))
	{
		return;
	}
}

//////////////////////////////////////////////////////////////////////
// Funktionen
//////////////////////////////////////////////////////////////////////

bool SScreenMode::setDisplayMode(int width, int height, int bpp)
{
	DEVMODE displayMode;

	memset(&displayMode, 0 , sizeof(displayMode));

	displayMode.dmSize          = sizeof(displayMode);		
	displayMode.dmPelsWidth	    = width;			
	displayMode.dmPelsHeight	= height;	
	displayMode.dmBitsPerPel	= bpp;		
	displayMode.dmFields        =  DM_BITSPERPEL | 
								   DM_PELSWIDTH  |
								   DM_PELSHEIGHT;

	if (ChangeDisplaySettings(&displayMode , CDS_FULLSCREEN)
		!= DISP_CHANGE_SUCCESSFUL)
	{
		return false;
	}
	

	return true;
}

void SScreenMode::reset()
{
	ChangeDisplaySettings(NULL,0);
}


